"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isInt_1 = __importDefault(require("validator/lib/isInt"));
const invalidValue_1 = __importDefault(require("../exceptions/invalidValue"));
const _1 = __importDefault(require("."));
class IntId extends _1.default {
    fromInput() {
        const _input = this.input;
        if (_input === null) {
            return null;
        }
        if (typeof _input === 'number') {
            return Math.floor(_input);
        }
        return Math.floor(parseFloat(_input));
    }
    toOutput() {
        if (this.inner === null) {
            throw new invalidValue_1.default('id');
        }
        return super.toOutput();
    }
    isSet() {
        return this.input !== null && this.input !== undefined;
    }
    getErrors(name) {
        const num = this.fromInput();
        if (num === null) {
            return undefined;
        }
        if (typeof this.input === 'string' && !(0, isInt_1.default)(this.input)) {
            return [{ name, error: '整数の形式が正しくありません' }];
        }
        if (!Number.isSafeInteger(num)) {
            return [{ name, error: '有効な整数ではありません' }];
        }
        return undefined;
    }
    compare(value) {
        const diff = this.value - value.value;
        if (diff < 0)
            return -1;
        if (diff > 0)
            return 1;
        return 0;
    }
}
exports.default = IntId;
//# sourceMappingURL=intId.js.map